<template>
  <div class="app-container">
      <SearchBlock v-model="queryParams" v-show="showSearch" size="mini" :menus="queryOption" @change="handleQuery"></SearchBlock>
    <!-- <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">


      <el-form-item label="单据编号" prop="billNumber">
        <el-input
          v-model="queryParams.billNumber"
          placeholder="请输入单据编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="航次号" prop="voyageNo">
        <el-input
          v-model="queryParams.voyageNo"
          placeholder="请输入航次号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="船舶名称" prop="vesselName">
        <el-input
          v-model="queryParams.vesselName"
          placeholder="请输入船舶名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="货物名称" prop="cargoName">
        <el-input
          v-model="queryParams.cargoName"
          placeholder="请输入货物名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>


      <el-form-item label="仓库名称" prop="stockCode" class="search-item">
        <el-select v-model="queryParams.stockCode" filterable placeholder="请选择">
          <el-option v-for="dict in warehouses" :key="dict.stockCode" :label="dict.stockName" :value="dict.stockCode">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="仓位名称" prop="stockName" class="search-item">
        <el-select v-model="queryParams.stockName" filterable placeholder="请选择">
          <el-option v-for="dict in stockList" :key="dict.stockName" :label="dict.stockName" :value="dict.stockName">
          </el-option>
        </el-select>
      </el-form-item>


      <el-form-item label="报关单号" prop="customsNo">
        <el-input
          v-model="queryParams.customsNo"
          placeholder="请输入报关单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="核注清单号" prop="listNumber" >
        <el-input
          v-model="queryParams.listNumber"
          placeholder="请输入核注清单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="项号" prop="bookNumber" >
        <el-input
          v-model="queryParams.bookNumber"
          placeholder="请输入项号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="单据日期" prop="queryTime">
        <el-date-picker clearable
                        v-model="queryTime"
                        type="daterange"
                        :picker-options="pickerOptions"
                        value-format="yyyy-MM-dd"
                        end-placeholder="结束日期"
                        range-separator="-" start-placeholder="开始日期"
                        placeholder="请选择单据日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="有效期至" prop="queryTime">
        <el-date-picker clearable
                        v-model="queryTimeTwo"
                        size="small"
                        :picker-options="pickerOptions"
                        end-placeholder="结束日期"
                        range-separator="-" start-placeholder="开始日期" type="daterange"
                        value-format="yyyy-MM-dd"
                        placeholder="请选择有效期至">
        </el-date-picker>
      </el-form-item>


      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form> -->

    <el-row :gutter="10" class="mb8">


      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['jxc:ckcargo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" highlight-current-row :data="ckcargoList"  @sort-change="handleSortChange"  @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="单据编号" align="center" prop="billNumber" sortable='custom' width="100"/>
      <el-table-column label="单据日期" align="center" prop="billDate" width="180" sortable='custom'>
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.billDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="仓库名称" align="center" prop="stockCode" sortable='custom' width="120">
        <template slot-scope="scope">
          <WarehouseName :stockCode="scope.row.stockCode"/>/{{scope.row.stockName}}
        </template>
      </el-table-column>
      <el-table-column label="仓位名称" align="center" prop="stockName" sortable='custom' width="100" v-if="false"/>
      <el-table-column label="货主名称" align="center" prop="custName" sortable='custom' width="100"/>
      <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom' width="100"/>
      <el-table-column label="出库件数" align="center" prop="cargoNum" sortable='custom' width="130"/>
      <el-table-column label="出库重量" align="center" prop="cargoWt" sortable='custom' width="130"/>
      <el-table-column label="出库体积" align="center" prop="cargoVol" sortable='custom' width="130"/>
      <el-table-column label="出库货物价值" align="center" prop="cargoValue" sortable='custom' width="100"/>
        <el-table-column label="货物自然序号" align="center" prop="cargoNumber" sortable='custom' width="130" />
        <el-table-column label="商品料号" align="center" prop="itemNumber" sortable='custom' width="100" />
        <el-table-column label="电子账册项号" align="center" prop="bookNumber" sortable='custom' width="130"/>
      <el-table-column label="HS编号" align="center" prop="hsCode" sortable='custom' width="100" />
        <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom' width="100"/>
        <el-table-column label="规格类型品质" show-overflow-tooltip align="center" prop="cargoSpec" sortable='custom' min-width="200"/>
        <el-table-column label="原产国" align="center" prop="originCountry" sortable='custom' width="100"/>
        <el-table-column label="报关单号" align="center" prop="customsNo" sortable='custom' width="100"/>
        <el-table-column label="核注清单号" align="center" prop="listNumber" sortable='custom' width="130"/>
      <el-table-column label="提运单号" align="center" prop="billNo" sortable='custom' width="100"/>
      <el-table-column label="船舶信息" align="center">
        <el-table-column label="航次号" align="center" prop="voyageNo" sortable='custom' width="100"/>
        <el-table-column label="船舶名称" align="center" prop="vesselName" sortable='custom' width="100"/>
      </el-table-column>
      <el-table-column label="有效期至" align="center" prop="expiryDate" width="180" sortable='custom'>
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.expiryDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
    </el-table>
    <el-row>
      <el-col :span="12" class="text-right"  style=" margin-top: 10px; margin-left: 10px">
               <span style="font-size: 16px">总重量: {{ totalWeight }}</span>
      </el-col>
    </el-row>
    <pagination
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />


  </div>
</template>

<script>
import { pageListCkcargo, getCkcargo, delCkcargo, addCkcargo, updateCkcargo,selectTotalWt } from "@/api/jxc/ckcargo";
import { listStock } from "@/api/jxc/stock";
import { listCust } from "@/api/jxc/cust";
import { listCargo } from "@/api/jxc/cargo";
import {listVessel,} from "@/api/jxc/vessel";
import {listBmvoyage} from "@/api/jxc/bmvoyage";
import {listCkbill} from "@/api/jxc/ckbill";
import {listWarehouse} from "@/api/jxc/warehouse";
import { datePickerOpts } from "@/utils";


export default {
  name: "Outstock",
  dicts: ['sys_business_nature', 'sys_trade_nature','sys_inbound_outbound_type'],
  data() {
    return {
      //仓库名称、项号、核注清单号、有效期至
      queryOption: [
        {
          label: '仓库名称',
          prop: 'stockCode',
          type: 'select',
          getOptions: () => this.warehouses,
          optionsProp: 'stockCode',
          optionsLabel: 'stockName',
        },
        {
          label: '项号',
          prop: 'bookNumber',
          type: 'text',
        },
        {
          label: '核注清单号',
          prop: 'listNumber',
          type: 'text',
          labelWidth: '90px'
        },
        {
          label: '有效期至',
          prop: 'excTime',
          type: 'daterange',
          options: datePickerOpts()
        },
        {
          label: '单据编号',
          prop: 'billNumber',
          type: 'text',
        },
        {
          label: '船舶名称',
          prop: 'vesselName',
          type: 'text',
        },
        {
          label: '货物名称',
          prop: 'cargoName',
          type: 'text',
        },
        {
          label: '航次',
          prop: 'voyageNo',
          type: 'text',
        },
        {
          label: '仓位名称',
          prop: 'stockName',
          type: 'select',
          getOptions: () => this.stockList,
          optionsProp: 'stockName',
          optionsLabel: 'stockName',
        },
        {
          label: '报关单号',
          prop: 'customsNo',
          type: 'text',
        },
        {
          label: '单据日期',
          prop: 'queryTime',
          type: 'daterange',
          options: datePickerOpts()
        },
      ],
      activeName: ['1', '2', '3'],
      totalWeight: 0,
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 选中名字
      names: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 仓库名称数据
      warehouses: [],
      // 有效期
      queryTimeTwo: [],
      // 单据时间
      queryTime: [],
      // 单据表格数据
       billList: [],
      // 船舶航次表格数据
      bmvoyageList: [],
      // 船舱表格数据
      vesselList: [],
      // 客户表格数据
      custList: [],
      // 货物表格数据
      cargoList: [],
      // 仓库表格数据
      stockList: [],
      // 仓库出库管理表格数据
      ckcargoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: '2',
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
        beginDate: null,
        endDate: null,
        beginDateTwo: null,
        endDateTwo: null,
        bookNumber: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        stockId: [
          { required: true, message: "库场ID不能为空", trigger: "blur" }
        ],
        billDate: [
          { required: true, message: "单据日期不能为空", trigger: "blur" }
        ],
        billNumber: [
          { required: true, message: "单据编号不能为空", trigger: "blur" }
        ],
        voyageNo: [
          { required: true, message: "航次号不能为空", trigger: "blur" }
        ],
        vesselName: [
          { required: true, message: "船舶名称不能为空", trigger: "blur" }
        ],
        cargoName: [
          { required: true, message: "货物名称不能为空", trigger: "blur" }
        ],
        billNo: [
          { required: true, message: "提运单号不能为空", trigger: "blur" }
        ],
        cargoWt: [
          { required: true, message: "货物重量不能为空", trigger: "blur" }
        ],
        cargoNum: [
          { required: true, message: "货物件数不能为空", trigger: "blur" }
        ],
        cargoVol: [
          { required: true, message: "货物体积不能为空", trigger: "blur" }
        ],
        stockName: [
          { required: true, message: "库场名称不能为空", trigger: "blur" }
        ],
        custName: [
          { required: true, message: "货主名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getStockList();
    this.getCustList();
    this.getCargoList();
    this.getVesselList();
    this.getBmvoyage();
    this.getBillList();
    listWarehouse({}).then(response => {
      this.warehouses = response.data;
    });
  },
  methods: {
    //单据
    getBillList() {
      let param = {};
      listCkbill(param).then(response => {
        this.billList = response.data;
      }).catch(e => {
      });
    },
    setBillDetail(billId) {
      this.billList.forEach(ele => {
        if (ele.id == billId) {
          this.form.billName = ele.billName;
          this.form.billId = ele.id;
        }
      })
    },
    //航次
    setBmvoyageDetail(voyageId) {
      console.log(voyageId);
      this.bmvoyageList.forEach(ele => {
        if (ele.id == voyageId) {
          this.form.voyageNo = ele.voyageNo;
          this.form.vesselName = ele.vesselName;
          this.form.deptId = ele.deptId;
          this.form.vesselId = ele.vesselId;
          this.form.netTon = ele.netTon;
          this.form.opType = ele.opType;
        }
      })
    },
    getBmvoyage() {
      let param = {};
      listBmvoyage(param).then(response => {
        this.bmvoyageList = response.data;
      }).catch(e => {
      });
    },
    //船舶
    setVesselDetail(vesselId) {
      console.log(vesselId);
      this.vesselList.forEach(ele => {
        if (ele.id == vesselId) {
          console.log("aa:",ele.vesselName);
          this.form.vesselName = ele.vesselName;

        }
      })
    },
    getVesselList() {
      let param = {};
      listVessel(param).then(response => {
        this.vesselList = response.data;
      }).catch(e => {
      });
    },
    //货物
    setCargoDetail(cargoId) {
      console.log(cargoId);
      this.cargoList.forEach(ele => {
        if (ele.id == cargoId) {
          console.log("aa:",ele.cargoName);
          this.form.cargoName = ele.cargoName;
          this.form.hsCode = ele.hsCode;
          this.form.cargoSpec = ele.cargoSpec;
          this.form.originCountry = ele.originCountry;
        }
      })
    },
    getCargoList() {
      let param = {};
      listCargo(param).then(response => {
        this.cargoList = response.data;
      }).catch(e => {
      });
    },
    //客户
    setCustDetail(custId) {
      console.log(custId);
      this.custList.forEach(ele => {
        if (ele.id == custId) {
          console.log("aa:",ele.custName);
          this.form.custName = ele.custName;
          this.form.custCode = ele.custCode;
          this.form.custId = ele.id;
        }
      })
    },
    getCustList() {
      let param = {};
      listCust(param).then(response => {
        this.custList = response.data;
      }).catch(e => {
      });
    },
    //仓库
    setStockDetail(stockId) {
      this.stockList.forEach(ele => {
        if (ele.id == stockId) {
          console.log("aa:",ele.stockName);
          this.form.stockName = ele.stockName;
          this.form.stockCode = ele.stockCode;
        }
      })
    },
    getStockList() {
      let param = {};
      listStock(param).then(response => {
        this.stockList = response.data;
      }).catch(e => {
      });
    },
    /** 查询仓库出库管理列表 */
    getList() {
      this.loading = true;
      if(this.queryParams.queryTime){
        this.queryParams.beginDate=this.queryParams.queryTime[0];
        this.queryParams.endDate=this.queryParams.queryTime[1];
      }else{
        this.queryParams.beginDate=null;
        this.queryParams.endDate=null;
      }
      if(this.queryParams.excTime){
        this.queryParams.beginDateTwo=this.queryParams.excTime[0];
        this.queryParams.endDateTwo=this.queryParams.excTime[1];
      }else{
        this.queryParams.beginDateTwo=null;
        this.queryParams.endDateTwo=null;
      }
      pageListCkcargo(this.queryParams).then(response => {
        this.ckcargoList = response.rows;
        this.total = response.total;
        this.loading = false;
      }).catch(e => {
        this.loading = false;
      });
      selectTotalWt(this.queryParams).then(response => {
        this.totalWeight = response.data;
      }).catch(e => {
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: "2",
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        remark: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
        bookNumber:null,
      };
      this.resetForm("form");
    },
    //排序
    handleSortChange(col) {
      this.$sortBy(col, this.queryParams);
      this.getList();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryTime = [];
      this.queryTimeTwo = [];

      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.names = selection.map(item => item.id);
      this.single = selection.length!==1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加仓库出库管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getCkcargo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改仓库出库管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCkcargo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCkcargo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.id || this.names;
      this.$modal.confirm('是否确认删除"' + row.billNumber + '"的数据项？').then(function() {
        return delCkcargo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('jxc/ckcargo/export', {
        ...this.queryParams
      }, `仓库出库管理_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
